;; Achtung ATTINDB noch nicht angepat an ACAD 2000!!
;; Eine Routine (und untersttzende Funktionen) zum 
;; Auswhlen eines oder mehrerer Blcke, Auslesen des
;; Schlsselattributes, Suchen der entsprechenden Datenstze
;; in einer Datenbank (Access, Excel), Auslesen von bestimmten
;; Feldern und Aktualisieren der Attribute der gewhlten
;; Blcke. Basiert auf ATTDB.lsp von The Fleming Group
;; Angepat von Christian Khler
;;		    Marktgasse 7
;;		    04668 Grimma
;;		    koehler@dr-bormann.de
;; Version vom 9.3.2002 fr ACAD 2000 und hher
;; ADOLISP_Library.lsp von The Fleming group wird bentigt!! 
;; In EXCEL funktioniert das Aktualisieren der Datenbank bei mir nicht.
;;; A routine (and supporting functions) to extract
;;; attribute values from a block insert entity
;;; and insert the values into (or update the values
;;; in) a database.  See comments following the
;;; boilerplate for limitations and usage.  NOTE that
;;; this routine is largely "data-driven" by the data
;;; immediately following the introductory comments.
;;; Few (if any) revisions should be required to change 
;;; what the routine does.

;;; Copyright (C) 1998 by The Fleming Group

;;; Permission to use, copy, modify, and distribute this software
;;; for any purpose and without fee is hereby granted, provided
;;; that the above copyright notice appears in all copies and
;;; that both that copyright notice and the limited warranty and
;;; restricted rights notice below appear in all supporting
;;; documentation.

;;; THE FLEMING GROUP PROVIDES THIS PROGRAM "AS IS" AND WITH ALL
;;; FAULTS. THE FLEMING GROUP SPECIFICALLY DISCLAIMS ANY IMPLIED
;;; WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
;;; THE FLEMING GROUP DOES NOT WARRANT THAT THE OPERATION OF THE
;;; PROGRAM WILL BE UNINTERRUPTED OR ERROR FREE.

;;; REQUIRES AUTOCAD R2000!.  Probably will work under
;;; higher versions when they are available.

;;; REQUIRES UPPERCASE FIELD NAMES IN THE DATABASE!

;;; ONLY TEXT DATA FIELDS IN THE DATABASE ARE SUPPORTED!

;;;************************************************************

;;; Usage:

;;; At the AutoCAD "command" prompt, or from a menu macro:
;;;    DBinAtt
;;; From AutoLISP:
;;;    (c:DBinAtt)

;;; Return value:
;;;    none.

;;;***********************************************************************

(if (not ADOLISP_ConnectToDB) (load "ADOLISP_Library.lsp"))      

;;; Set up a global list that determines much of how this routine
;;; works

(setq #AttDBData
       '(
         ;; The name of the environment set up
         ;; for connecting to the database
         ("Datenbank" . "...")
         ;; The name of the table in the database
         ("Tabelle" . "....")
         ;; The login name to connect to the database
         ("LoginName" . "...")
         ;; The password to connect to the database
         ("Password" . "")
         ;; The name of the block from which we are
         ;; going to extract the attributes
         ("BlockName" . "...")
         ;; A list of the all fields in the database table,
         ;; paired with the tags of the atributes that
         ;; correspond with the fields.  THE FIELD NAMES
         ;; MUST APPEAR IN THE SAME ORDER THAT THEY
         ;; APPEAR IN THE DATABASE TABLE!!  All
         ;; names in the list must be uppercase.
         ;; All fields must be included; if a field does not
         ;; have a corresponding attribute, just use a null
         ;; string ("") for the attribute name.
         ("FieldNameList"
          ("..." . "...")
          ("..." . "...")
          ("..." . "")
          ("..." . "")
          ("..." . "...")
          ("..." . "....")
          ("...." . "...")
          ("..." . "")
          ("...." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "")
          ("..." . "...")
          ("..." . "...")
          ;("..." . "")
         ; ("...." . "")
          )
         ;; A list of the key field or fields of the
         ;; database table.  The field or fields contained
         ;; in this list should be sufficient to extract
         ;; one record from the database.  The field
         ;; names in this list must be uppercase.  All
         ;; fields listed here must have corresponding
         ;; attributes (not null strings) listed in the
         ;; Field List above.
         ("KeyFieldList" ("..."))
        )
) ;_ end setq

;;; Lordy me, we're actually going to start defining the
;;; real routine now!

(defun C:DBinAtt (/ GEH_OldErrorHandler GEH_OldUndoCtl SelectionSet  ;;1
                     AttributeList InsertEntityName DBIdentifier
                     SQLResult KeyFieldSpec UpdateSpec ValueSpec
                     AttributeValue AttributeTag
                    )

  ;; Replace AutoCAD's standard error handler ... change
  ;; "T" to "NIL" for debugging
  ;(if T
  ;  (progn
  ;    (setq GEH_OldErrorHandler
  ;           *error*
  ;          *error* GEH_ErrorHandler
  ;    ) ;_ end setq
  ;  ) ;_ end progn
  ;) ;_ end if

  ;; Start an UNDO GROUP
  ;(GEH_UndoBegin)

(setq Zeile 0)
  ;; If there is a block with the appropriate name inserted
  ;; in the drawing and it has attributes ...
  (if (setq SelectionSet  ;;2
             (ssget 
                    (list '(0 . "INSERT")
                          (cons 2 (GetGlobalData "BlockName"))
                          '(66 . 1)
                    ) ;_ end list
             ) ;_ end ssget
      ) ;_ end setq
    (progn  ;; 3
      (prompt (strcat "Block gefunden: \""
                      (GetGlobalData "BlockName")
                      "\" ... "
              ) ;_ end strcat
      ) ;_ end prompt
      ;; If DBL.LSP is already loaded or we can find it and load it ...
;;*********************************************************************
;; Anpassung an ACAD 2000
  ;; Connecting to the database ...
  ;=======================================================================================================
  (setq ConnectString
	 (strcat "Provider=MSDASQL;Driver={Microsoft Access Driver (*.mdb)};DBQ=" (GetGlobalData "Datenbank")))
  (prompt (strcat "\n\nConnecting to the database using \n\""
          ConnectString
                  "\""
          )
  ); end prompt
  (if (not (setq ConnectionObject (ADOLISP_ConnectToDB ConnectString "" "" )))
    (progn
      (prompt "\nConnection failed!")
      (ADOLISP_ErrorPrinter)
    )
    (prompt "\nResult: succeeded!")
  );end if

(progn  ;; 7
              ;; Build a string that specifies the selection criteria
              ;; for finding a record that matches the block insert
              ;; we're working with.  First initialize the string.
    (repeat (sslength Selectionset) ;Hauptschleife fr alle ausgew. Blcke 26
              (setq AttributeList (GetInsertAttributes (ssname SelectionSet Zeile)))
              (setq KeyFieldSpec "")
              ;; Now loop over each key field
              (foreach KeyField (car (GetGlobalData "KeyFieldList"))
                (setq KeyFieldSpec
                       (strcat
                         KeyFieldSpec
                         " "
                         KeyField
                         " = '"
			 ;" = "
			 ;; To get the value for the key field, we look up
                         ;; the attribute tag that corresponds to it in
                         ;; the Field Name List, then look up the value
                         ;; of that attribute for this block
                         (cdr (assoc
                                (cdr (assoc
                                       KeyField
                                       (GetGlobalData "FieldNameList")
                                     ) ;_ end assoc
                                ) ;_ end cdr
                                AttributeList
                              ) ;_ end assoc
                         ) ;_ end cdr
                         "' AND"
			 ;" AND"
                       ) ;_ end strcat
                ) ;_ end setq
              ) ;_ end foreach
              ;; We've got an extra " AND" on the end of the string,
              ;; strip it off
              
              (setq KeyFieldSpec
                     (substr KeyFieldSpec
                             1
                             (- (strlen KeyFieldSpec) 4)
                     ) ;_ end substr
              ) ;_ end setq
              ;;Now, we can check if there is already a record
              ;; corresponding to this drawing.

     
;; If we got a connection ...
  (if ConnectionObject  ;; 26a
    (progn
     ;; Retrieve some data
      
     (setq SQLStatement (strcat "SELECT * FROM " (GetGlobalData "Tabelle") " WHERE " KeyFieldSpec))


      (prompt (strcat "\n\nExecuting a SELECT statement to retrieve some data:\n\""
                      SQLStatement
                      "\""
              )
      )
      
      (if (setq Result (ADOLISP_DoSQL ConnectionObject SQLStatement)) ;8
        (progn
	  (prompt "\nResult:")
        )
        (progn
          (prompt "\nFailed!")
          (ADOLISP_ErrorPrinter)
        )
      ) ;8
     

 ;; We executed the statement successfully.  Now we can see
 ;; if there is an existing record ... (DBLDoSQL returns
 ;; a list; the first item is the column specifications and
 ;; the data is in succeeding items, so a list length of 1
 ;; means no record retrieved)
   (if (< 1 (length Result)) ;; 9
        (progn   ;; 10
           (setq Spalte 0) ; 
			   ;; Abfrage aller Felder der Datenbankzeile
           (setq neueAttribute nil)
           (foreach FieldAttributeList  ;;11
                     (GetGlobalData "FieldNameList")
                      ;; If there is an attribute associated with this
                      ;; field ...

;;************************neues Programm**************************************
		    (if     ;; 12
                        (/= "" (setq AttributeTag (cdr FieldAttributeList)))
       			(progn  ;; 20
			  (if   (= nil (setq AttributWert    ;; 22
                          (nth Spalte (cadr Result))))
					(progn  ;; 21
                          (setq Attributwert "  ")
				)) ; end progn 21 if 22
				(setq neueAttribute 
					(cons      ;; 25
				  ; Name des Attributes
				  (cons AttributeTag AttributWert) 
					neueAttribute
				)) ;; end cons 25, setq
			 ) ;; end progn 20
                   ) ;; end if 12
			(setq Spalte (+ Spalte 1))
			    ) ;_ end foreach  11
			;; Update der Attribute
                        (setq ELementname (ssname SelectionSet Zeile))
			(Attributeausgeben ElementName neueAttribute)
		       ) ;_ end progn 10
			) ; end if 9
;) ;_ end if 8 alt
(setq Zeile (+ 1 Zeile))
     ) ;end progn
    ); end if 26a
)  ; end repeat 26
;; All done, now we just disconnect from the database.
              (progn
                (prompt "Schlieen der Datenbankverbindung.")
                (if (not (ADOLISP_DisconnectFromDB ConnectionObject))
                  (alert
                    "Failed disconnecting from database!\nThere may be more information on the text screen"
                  ) ;_ end alert
                ) ;_ end if
              ) ;_ end progn
            ) ;_ end progn 7
            ;; Can't connect to the database
           ; (alert (strcat "Can't connect to environment \""
           ;                (GetGlobalData "Datenbank")
           ;                "\"\nlogging as \""
           ;                (GetGlobalData "LoginName")
           ;                "\"\nwith password \""
           ;                (GetGlobalData "Password")
           ;                "\""
           ;        ) ;_ end strcat
           ; ) ;_ end alert
          ;) ;_ end if 6
        ;) ;_ end progn 5
              
      ;) ;_ end if 4
    ) ;_ end progn 3
    ;; Can't find the block or it doesn't have attributes
    (alert (strcat "Either:\nCan't find an insert named \""
                   (GetGlobalData "Blockname")
                   "\nOr:\nIt has no attributes."
           ) ;_ end strcat
    ) ;_ end alert
  ) ;_ end if 2

  ;; End the UNDO Group and clean up
  ;(GEH_UndoEnd)
  ; (GEH_RestoreState NIL)

  ;; Clean finish with no return value printed to the screen
  (prin1)
) ;_ end defun 1

;;;*******************************************************************

;;;###################################################################
;;; Original attdb.lsp, nur um die repeat- Schleife erweitert
;;; REQUIRES UPPERCASE FIELD NAMES IN THE DATABASE!

;;; ONLY TEXT DATA FIELDS IN THE DATABASE ARE SUPPORTED!


;;; Lordy me, we're actually going to start defining the
;;; real routine now!

(defun C:AttinDB (/ GEH_OldErrorHandler GEH_OldUndoCtl SelectionSet
                     AttributeList InsertEntityName DBIdentifier
                     SQLResult KeyFieldSpec UpdateSpec ValueSpec
                     AttributeValue AttributeTag
                    )

  ;; Replace AutoCAD's standard error handler ... change
  ;; "T" to "NIL" for debugging
  (if T
    (progn
      (setq GEH_OldErrorHandler
             *error*
            *error* GEH_ErrorHandler
      ) ;_ end setq
    ) ;_ end progn
  ) ;_ end if

  ;; Start an UNDO GROUP
  (GEH_UndoBegin)

  (prompt "\nUpdating database ... ")
  (setq Zeile 0)
  ;; If there is a block with the appropriate name inserted
  ;; in the drawing and it has attributes ...
  (if (setq SelectionSet
             (ssget
                    (list '(0 . "INSERT")
                          (cons 2 (GetGlobalData "BlockName"))
                          '(66 . 1)
                    ) ;_ end list
             ) ;_ end ssget
      ) ;_ end setq
    (progn
      (prompt (strcat "Found insert of \""
                      (GetGlobalData "BlockName")
                      "\" ... "
              ) ;_ end strcat
      ) ;_ end prompt
      ;; We will ignore the possibility that there is more than one insert,
      ;; and we'll just grab the first one we found.  Get the attribute
      ;; values for it.
      (setq AttributeList (GetInsertAttributes (ssname SelectionSet Zeile)))
      ;; If DBL.LSP is already loaded or we can find it and load it ...
      (if (or DBLConnectToDB
              (and (findfile "DBL.LSP") (load "DBL.LSP"))
          ) ;_ end or
        (progn
          (prompt "\nConnecting to database ... ")
          ;; We've got DBL.LSP.  If we can connect to the database ...
          (if (setq DBIdentifier
                     (DBLConnectToDB
                       ""
                       (GetGlobalData "DBEnvironment")
                       (GetGlobalData "LoginName")
                       (GetGlobalData "Password")
                     ) ;_ end DBLConnectToDB
              ) ;_ end setq
            (progn
              ;; We've connected to the database.
              ;; Build a string that specifies the selection criteria
              ;; for finding a record that matches the block insert
              ;; we're working with.  First initialize the string.
(repeat (sslength Selectionset) ;Hauptschleife fr alle ausgew. Blcke 
      (setq AttributeList (GetInsertAttributes (ssname SelectionSet Zeile)))
              (setq KeyFieldSpec "")
              ;; Now loop over each key field
              (foreach KeyField (car (GetGlobalData "KeyFieldList"))
                (setq KeyFieldSpec
                       (strcat
                         KeyFieldSpec
                         " "
                         KeyField
                         " = '"
                         ;; To get the value for the key field, we look up
                         ;; the attribute tag that corresponds to it in
                         ;; the Field Name List, then look up the value
                         ;; of that attribute for this block
                         (cdr (assoc
                                (cdr (assoc
                                       KeyField
                                       (GetGlobalData "FieldNameList")
                                     ) ;_ end assoc
                                ) ;_ end cdr
                                AttributeList
                              ) ;_ end assoc
                         ) ;_ end cdr
                         "' AND"
                       ) ;_ end strcat
                ) ;_ end setq
              ) ;_ end foreach
              ;; We've got an extra " AND" on the end of the string,
              ;; strip it off
              (setq KeyFieldSpec
                     (substr KeyFieldSpec
                             1
                             (- (strlen KeyFieldSpec) 4)
                     ) ;_ end substr
              ) ;_ end setq
              ;;Now, we can check if there is already a record
              ;; corresponding to this drawing.
              (prompt "Checking for existing record ... ")
              ;; If we can execute the SQL statement ...
              (if (setq SQLResult
                         (DBLDoSQL DBIdentifier
                                   (strcat "SELECT * FROM "
                                           (GetGlobalData "TableName")
                                           " WHERE"
                                           KeyFieldSpec
                                   ) ;_ end strcat
                                   t
                         ) ;_ end DBLDoSQL
                  ) ;_ end setq
                ;; We executed the statement successfully.  Now we can see
                ;; if there is an existing record ... (DBLDoSQL returns
                ;; a list; the first item is the column specifications and
                ;; the data is in succeeding items, so a list length of 1
                ;; means no record retrieved)
                (if (< 1 (length SQLResult))
                  (progn
                    ;; There is an existing record.  Since we can't be sure
                    ;; if there's data that doesn't correspond to an
                    ;; attribute, we want to update it rather than
                    ;; deleting it and re-creating it (which would be
                    ;; simpler but wrong).  We'll just overwrite all
                    ;; the fields that correspond to attributes, rather
                    ;; than bothering to find out which attribute or
                    ;; attributes have changed.
                    ;; Build a string that contains the update
                    ;; specifications.  First initialize it:
                    (setq UpdateSpec "")
                    ;; Loop over all fields
                    (foreach FieldAttributeList
                             (GetGlobalData "FieldNameList")
                      ;; If there is an attribute associated with this
                      ;; field ...
                      (if
                        (/= ""
                            (setq AttributeTag (cdr FieldAttributeList))
                        ) ;_ end /=
                         ;; If the attribute value is not a null string ...
                         (if (/= ""
                                 (setq AttributeValue
                                        (cdr (assoc AttributeTag AttributeList))
                                 ) ;_ end setq
                             ) ;_ end /=
                           ;; Then update the value of the attribute
                           (setq UpdateSpec
                                  (strcat UpdateSpec
                                          (car FieldAttributeList)
                                          " = '"
                                          AttributeValue
                                          "', "
                                  ) ;_ end strcat
                           ) ;_ end setq
                           ;; The attribute value is a null string, use
                           ;; SQL NULL for its value in case the "allow
                           ;; zero length" property isn't on for this
                           ;; field
                           (setq UpdateSpec
                                  (strcat UpdateSpec
                                          (car FieldAttributeList)
                                          " = NULL, "
                                  ) ;_ end strcat
                           ) ;_ end setq
                         ) ;_ end if
                         ;; There's no attribute associated with this
                         ;; field, ignore it.
                      ) ;_ end if
                    ) ;_ end foreach
                    ;; We've got an extra ", " on the end of the string,
                    ;; strip it off
                    (setq UpdateSpec
                           (substr UpdateSpec
                                   1
                                   (- (strlen UpdateSpec) 2)
                           ) ;_ end substr
                    ) ;_ end setq
                    ;; If we succeed in updating the record ...
                    (if (DBLDoSQL DBIdentifier
                                  (strcat "UPDATE "
                                          (GetGlobalData "TableName")
                                          " SET "
                                          UpdateSpec
                                          " WHERE "
                                          KeyFieldSpec
                                  ) ;_ end strcat
                                  t
                        ) ;_ end DBLDoSQL
                      ;; Tell the user
                      (prompt "Existing record updated ... ")
                      ;; Failed updating, warn the user
                      (alert
                        "Failed updating the record!\nThere may be more information on the text screen."
                      ) ;_ end alert
                    ) ;_ end if
                  ) ;_ end progn
                  ;; Finished with updating an existing record.
                  (progn
                    ;; There is no record for corresponding to this block
                    ;; insert, we have to create one.
                    ;; Initialize a string for the values
                    (setq ValueSpec "")
                    ;; Loop over all fields
                    (foreach FieldAttributeList
                             (GetGlobalData "FieldNameList")
                      ;; If there is an attribute associated with this
                      ;; field ...
                      (if
                        (/= ""
                            (setq AttributeTag (cdr FieldAttributeList))
                        ) ;_ end /=
                         ;; If the attribute value is not a null string ...
                         (if (/= ""
                                 (setq AttributeValue
                                        (cdr (assoc AttributeTag AttributeList))
                                 ) ;_ end setq
                             ) ;_ end /=
                           ;; Then insert the value of the attribute
                           (setq ValueSpec
                                  (strcat ValueSpec
                                          "'"
                                          AttributeValue
                                          "', "
                                  ) ;_ end strcat
                           ) ;_ end setq
                           ;; The attribute value is a null string, use
                           ;; SQL NULL for its value in case the "allow
                           ;; zero length" property isn't on for this
                           ;; field
                           (setq ValueSpec
                                  (strcat ValueSpec
                                          "NULL, "
                                  ) ;_ end strcat
                           ) ;_ end setq
                         ) ;_ end if
                         ;; There's no attribute associated with this
                         ;; field, stick in an SQL NULL.
                         (setq ValueSpec
                                (strcat ValueSpec
                                        "NULL, "
                                ) ;_ end strcat
                         ) ;_ end setq
                      ) ;_ end if
                    ) ;_ end foreach
                    ;; We've got an extra ", " on the end of the string,
                    ;; strip it off and add the "(" at the beginning
                    ;; and the ")" at the end
                    (setq ValueSpec
                           (strcat "("
                                   (substr ValueSpec
                                           1
                                           (- (strlen ValueSpec) 2)
                                   ) ;_ end substr
                                   ")"
                           ) ;_ end strcat
                    ) ;_ end setq
                    ;; If we succeed in inserting the record ...
                    (if (DBLDoSQL DBIdentifier
                                  (strcat "INSERT INTO "
                                          (GetGlobalData "TableName")
                                          " VALUES "
                                          ValueSpec
                                  ) ;_ end strcat
                                  t
                        ) ;_ end DBLDoSQL
                      ;; Tell the user
                      (prompt "New record inserted ... ")
                      ;; Failed updating, warn the user
                      (alert
                        "Failed inserting the record!\nThere may be more information on the text screen."
                      ) ;_ end alert
                    ) ;_ end if
                  ) ;_ end progn
                  ;; Done inserting a new record
                ) ;_ end if
                ;; From here on, we see the error messages that show up
                ;; if something failed earlier.
                ;; Failed executing the SQL statement to check for
                ;; an existing record
                (alert
                  "Failed checking for an existing record!\nThere may be more information on the text screen."
                ) ;_ end alert
              ) ;_ end if
(setq Zeile (+ 1 Zeile))
)  ; end repeat 26
              ;; All done, now we just disconnect from the database.
              (progn
                (prompt "Disconnecting from database.")
                (if (not (DBLDisconnectFromDB DBIdentifier))
                  (alert
                    "Failed disconnecting from database!\nThere may be more information on the text screen"
                  ) ;_ end alert
                ) ;_ end if
              ) ;_ end progn
            ) ;_ end progn
            ;; Can't connect to the database
            (alert (strcat "Can't connect to environment \""
                           (GetGlobalData "DBEnvironment")
                           "\"\nlogging as \""
                           (GetGlobalData "LoginName")
                           "\"\nwith password \""
                           (GetGlobalData "Password")
                           "\""
                   ) ;_ end strcat
            ) ;_ end alert
          ) ;_ end if
        ) ;_ end progn
        ;; Can't find or load DBL.LSP
        (alert
          "Can't find DBL.LSP!\nEnsure it is available in a directory in\nAutoCAD's search path"
        ) ;_ end alert
      ) ;_ end if
    ) ;_ end progn
    ;; Can't find the block or it doesn't have attributes
    (alert (strcat "Either:\nCan't find an insert named \""
                   (GetGlobalData "Blockname")
                   "\nOr:\nIt has no attributes."
           ) ;_ end strcat
    ) ;_ end alert
  ) ;_ end if

  ;; End the UNDO Group and clean up
  (GEH_UndoEnd)
  (GEH_RestoreState NIL)

  ;; Clean finish with no return value printed to the screen
  (prin1)
) ;_ end defun

;;;*******************************************************************

;;; Support routines.

;;; A function to extract data from the global data list.

;;; Argument:
;;;    A string corresponding to the first item in a sublist
;;;    of the global data list.

;;; Return Value:
;;;    NIL if there is no corresponding item in the global
;;;    data list.  Otherwise, the sublist with the
;;;    first item stripped off.

(defun GetGlobalData (Key)
  (cdr (assoc Key #AttDBData))
) ;_ end defun

;;; A function to extract all the attribute values of a block insert
;;; entity.

;;; Argument:  the Entity Name of the insert entity.

;;; Return Value:  NIL if the insert has no attributes, otherwise
;;; a list of lists.  Each sub-list is a dotted pair of strings,
;;; ("Attribute Tag" . "Attribute Value")

(defun GetInsertAttributes (InsertEName / EList ReturnValue)
  ;; Get the Entity Association List of the entity, check that it
  ;; is a block insert and has attributes.  If we're OK ...
  (if (and (= "INSERT"
              (cdr (assoc 0 (setq EList (entget InsertEname))))
           ) ;_ end =
           (= (cdr (assoc 66 EList)) 1)
      ) ;_ end and
    ;; Get the next entity's Entity Association List.  As long as
    ;; the next entity is not a SEQEND entity ...
    (while
      (not
        (=
          "SEQEND"
          (cdr
            (assoc 0
                   (setq EList (entget (entnext (cdr (assoc -1 EList)))))
            ) ;_ end assoc
          ) ;_ end cdr
        ) ;_ end =
      ) ;_ end not
       ;; It's an attribute.  Extract the tag and value and add it
       ;; to the return value list.
       (setq ReturnValue
              (cons
                (cons (cdr (assoc 2 EList)) (cdr (assoc 1 EList)))
                ReturnValue
              ) ;_ end cons
       ) ;_ end setq
    ) ;_ end while
  ) ;_ end if
  ;; Reverse the list so it's in the same order that we found the
  ;; attributes.  Note that the last thing evaluated in the
  ;; function becomes the return value of the function
  (reverse ReturnValue)
) ;_ end defun 1

;;;*************************************************************

(defun Attributeausgeben (EN ATTS / EN1 EL)
   (setq EN1 EN)
  
   (if (atom (car ATTS)) ;;is first list element an atom?
      ;;update sequential
     
      (foreach ATT ATTS
	(alert "1")
         (setq EN (entnext EN)  ;;get the next entity
               EL (entget EN)   ;;it is an attribute
               EL (subst (cons 1 ATT)  ;;substitute the value
                         (assoc 1 EL) EL)
         )
         (entmod EL) ;;update it in the drawing database
      )
      ;;else update by tag names
      (while (= "ATTRIB"
                (cdr (assoc 0
                  (setq EL (entget
                     (setq EN (entnext EN)))))))
         (if (assoc (cdr (assoc 2 EL)) ATTS)

	   (entmod (subst
               (cons 1 
                  (cdr ;;use CDR if dotted pairs origian cadr
                    (assoc 
                       (cdr (assoc 2 EL)) 
                       ATTS)))
               (assoc 1 EL)
               EL)
            )
         )
      )
   )
   ;;
   ;; Regenerate the block insert and attributes.
   ;;
   (entupd EN1)
)


;;;*************************************************************

;;; The following routines implement a General Error Handler.  The
;;; routine GEH_SaveState is not actually called in Revision 1.0
;;; of this overally system, but it is included for completeness.

;;; Function to save some set of system variables.  Each element of the
;;; argument list "s_list" should be either the name of a system variable
;;; to be saved, or a list of strings starting with "COMMAND" and followed
;;; by strings or quoted items that will reset the desired item.  (the second
;;; form is for resetting read-only stuff such as current layer).

;;; Returns a list of either dotted pairs of a system variable name and its
;;; current value, or the commands to be fed to the "command" function
;;; to restore the state

(defun GEH_SaveState (s_list / tmp_l)
  ;; Set up an empty list for the return value
  (setq tmp_l '())
  ;; For each item in the list of variables to be saved ...
  (foreach next_v s_list
    ;; If the item is a list ...
    (if (listp next_v)
      ;; Then it must be a command, just store it
      (setq tmp_l (cons next_v tmp_l))
      ;; It's not a list, it must be a system variable name.  Put it into
      ;; a dotted pair list with its current value, and add that list to
      ;; the final list
      (setq tmp_l (cons (cons next_v (getvar next_v)) tmp_l))
    ) ;_ end if
  ) ;_ end foreach
) ;_ end defun

;;; Function to restore a set of system variables from the values in its
;;; argument, previously set up by the GEH_SaveState function

(defun GEH_RestoreState (tmp_l / cmdstr)
  ;; If there is indeed a list of values to restore ...
  (if tmp_l
    (progn
      ;; Restore the values
      (foreach next_v tmp_l
        ;; If it starts with the string "command" ...
        (if (= (strcase (car next_v)) "COMMAND")
          ;; Then it must be a set of strings to pass to the (command ...)
          ;; function
          (progn
            (setq cmdstr (cdr next_v))
            (foreach next_c cmdstr
              (command next_c)
            ) ;_ end foreach
          ) ;_ end progn
          ;; Otherwise, it's a variable name and its value to reset to
          ;; Check for special cases ...
          (cond
            (
             (= (strcase (car next_v)) "CECOLOR")
             (cond
               (
                (= (cdr next_v) 0)
                (command "._COLOR" "_BYBLOCK")
               )
               (
                (= (cdr next_v) 256)
                (command "._COLOR" "_BYLAYER")
               )
               (
                T
                (command "._COLOR" (cdr next_v))
               )
             ) ;_ end cond
            )
            (
             T
             (setvar (car next_v) (cdr next_v))
            )
          ) ;_ end cond
        ) ;_ end if
      ) ;_ end foreach
      ;; NIL out the list
      (setq tmp_l NIL)
    ) ;_ end progn
  ) ;_ end if
  ;; If there is a previous error handler ...
  (if GEH_OldErrorHandler
    ;; Re-install the original error handler
    (setq *error* GEH_OldErrorHandler)
  ) ;_ end if
) ;_ end defun

;;; Error handler for the system, to make sure system variables are
;;; restored and the screen doesn't fill up with LISP if the user
;;; presses Control-C

(defun GEH_ErrorHandler (msg)
  ;; Cancel any pending command and end any UNDO group
  (command)
  (command)
  (command)
  (GEH_UndoEnd)
  ;; If the message is just a user cancelling ...
  (if (member msg '("console break" "Function cancelled"))
    ;; Print a message without "Error"
    (princ (strcat "\n" msg "\n"))
    ;; Otherwise, print an error indication
    (princ
      (strcat "\nError " (itoa (getvar "ERRNO")) ": " msg "\n")
    ) ;_ end princ
  ) ;_ end if
  ;; Restore system variables
  (GEH_RestoreState save_l)
  ;; If there is a previous error handler AND it's not the ORIGINAL original
  ;;  error handler loaded with AutoLISP ...
  (if (and GEH_OldErrorHandler (not (eq (type *error*) 'SUBR)))
    ;; Give it a chance to restore its original error handler
    ;;  (this can happen when the user cancels out of [or an error
    ;;  occurs in] a function that's been autoloaded)
    (*error* msg)
  ) ;_ end if
  ;; Clean finish with no return value
  (prin1)
) ;_ end defun

;;; Start an UNDO GROUP. Originally from Tony Tanzillo, through
;;; Tim Morse, modified by Jon Fleming

;;; No useful return value.

;;; GEH_OldUndoCtl should be defined as a local variable in
;;; the calling function.

(defun GEH_UndoBegin (/)
  ;; If UNDO is not disabled ...
  (if (not (= 0 (setq GEH_OldUndoCtl (getvar "UNDOCTL"))))
    (progn
      ;; If it's set to only undo one command ...
      (if (= 1 (boole 1 2 GEH_OldUndoCtl))
        ;; Change it
        (command "._undo" "_control" "_all")
      ) ;_ end if
      ;; If auto-group for menu items is enabled ...
      (if (= 1 (boole 1 4 GEH_OldUndoCtl))
        (command "._undo" "_auto" "_off")
        ;; Change it
      ) ;_ end if
      ;; If a group is active ...
      (if (= 1 (boole 1 8 GEH_OldUndoCtl))
        ;; End it
        (command "._undo" "_end")
      ) ;_ end if
      ;; Start our group
      (command "._undo" "_group")
    ) ;_ end progn
    ;; UNDO is disabled, OK, we won't do anything.
  ) ;_ end if
) ;_ end defun

;;; End an UNDO GROUP. Originally from Tony Tanzillo, through
;;; Tim Morse, modified by Jon Fleming

;;; No useful return value.

;;; GEH_OldUndoCtl should be defined as a local variable in the
;;; calling function.

(defun GEH_UndoEnd (/)
  ;; If UNDO is not disabled ...
  (if (not (= 0 GEH_OldUndoCtl))
    (progn
      ;; End our UNDO group
      (command "._UNDO" "_END")
      ;; If we were set to undo only one command ...
      (if (= 1 (boole 1 2 GEH_OldUndoCtl))
        ;; Restore that
        (command "._undo" "_control" "_one")
      ) ;_ end if
      ;; If auto-group for menu items was enabled ...
      (if (= 1 (boole 1 4 GEH_OldUndoCtl))
        ;; Enable it
        (command "._UNDO" "_CONTROL" "_ONE")
      ) ;_ end if
    ) ;_ end progn
    ;; UNDO is disabled, do nothing.
  ) ;_ end if
) ;_ end defun

(defun Attributeausgeben (EN ATTS / EN1 EL)
   (setq EN1 EN)
   (if (atom (car ATTS)) ;;is first list element an atom?
      ;;update sequential
      (foreach ATT ATTS
         (setq EN (entnext EN)  ;;get the next entity
               EL (entget EN)   ;;it is an attribute
               EL (subst (cons 1 ATT)  ;;substitute the value
                         (assoc 1 EL) EL)
         )
         (entmod EL) ;;update it in the drawing database
      )
      ;;else update by tag names
      (while (= "ATTRIB"
                (cdr (assoc 0
                  (setq EL (entget
                     (setq EN (entnext EN)))))))
         (if (assoc (cdr (assoc 2 EL)) ATTS)
            (entmod (subst
               (cons 1 
                  (cdr ;;use CDR if dotted pairs origian cadr
                    (assoc 
                       (cdr (assoc 2 EL)) 
                       ATTS)))
               (assoc 1 EL)
               EL)
            )
         )
      )
   )
   ;;
   ;; Regenerate the block insert and attributes.
   ;;
   (entupd EN1)
)




;;; Clean finish to the loading of this file
(prin1)



